

makeTransferFunction <- function(lower_limit = 0, upper_limit = 15000) {
  warning("function broken.")
  A <- lower_limit
  K <- upper_limit - A
  mid <- 0.5 * (lower_limit + upper_limit)
  Q <- 1
  objfun <- function(x) { #B, nu, Q, M) {
    B <- x[1]
    nu <- x[2]
    Q <- x[3]
    M <- x[4]
    
    (-upper_limit + A + K / (1 + Q * exp(-B * (upper_limit - M))) ^ (1 / nu)) ^ 2 +
    #(-mid + A + K / (1 + Q * exp(-B * (mid - M))) ^ (1 / nu)) ^ 2 +
    (-lower_limit + A + K / (1 + Q * exp(-B * (lower_limit - M))) ^ (1 / nu)) ^ 2
  }
  res <- nlminb(c(0.1, 0.1, 0.1, 0.1), objfun, gamma=4)

  if (res$convergence != 0)
    warning("Convergence not achieved.")
  
  B <- res$par[1]
  nu <- res$par[2]
  Q <- res$par[3]
  M <- res$par[4]

  
  f <- function(t)
    {
      A + K / (1 + Q * exp(-B * (t - M))) ^ (1 / nu)  
    }

  return(f)
}



expression_arraywide <- function(n,
    noise_mean = 50, noise_sd = 5,
    signal_mean = 500, signal_sd = 0.9,
    highbump_percent = 5, highbump_mean = 6000, highbump_sd=500)
{
  if (highbump_percent > 100 | highbump_percent < 0) {
    stop("'highbump_percent is expected to be an integer between 0 and 100.'")
  }
  n_highbump <- as.integer(n * highbump_percent / 100)
  res <-
    rnorm(n, mean = noise_mean, sd = noise_sd) +
      c(rlnorm(n - n_highbump, meanlog = log(signal_mean), sdlog = signal_sd),
        rnorm(n_highbump, mean = highbump_mean, sd = highbump_sd))
  
  return(res)
}

replicate_arraywide <- function(x)
{
  x + rnorm(length(x), sd = x/2) + rnorm(1, sd = IQR(x, 0.25))
}

## f <- makeTransferFunction()

## x <- expression_arraywide(1000)

## plot(sort(x), f(sort(x)), type="b")


## x2 <- replicate_arraywide(x)
## x3 <- replicate_arraywide(x)

## plot(x, x2)

## plot(f(x), f(x2))


## library(affy)
## m <- cbind(x, x2, x3)
## plotDensity(m)

## mn <- normalize.quantiles(m)
## plotDensity(mn)


## y <- expression_arraywide(1000)
## y2 <- replicate_arraywide(y)
## y3 <- replicate_arraywide(y)

## m <- cbind(x, x2, x3, y, y2, y3)
## mn <- normalize.quantiles(m)

## par(mfrow=c(1,2))
## plotDensity(m, col=rep(c(1,2), c(3,3)))
## plotDensity(mn, col=rep(c(1,2), c(3,3)))

## boxplot(m[1, 1:3], m[1, 4:6])
## boxplot(mn[1, 1:3], mn[1, 4:6])
