\name{createProbeCoords}
\alias{createProbeCoords}

\title{ Create probe coordinates }
\description{
  Create probe coordinates
}
\usage{
createProbeCoords(nrows, ncols,
                  meta_nrows = 1, meta_ncols = 1,
                  meta_padding = 5)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{nrows}{ Number of rows per sub-array }
  \item{ncols}{ Number of columns per sub-array }
  \item{meta_nrows}{ Number of sub-arrays per row }
  \item{meta_ncols}{ Number of sub-arrays per column }
  \item{meta_padding}{ Padding between sub-arrays }
}
%\details{
%  
%}
\value{
  A \code{data.frame} of columns:
  \item{row}{row position within the sub-array}
  \item{col}{column position within the sub-array}
  \item{metarow}{sub-array index in the row}
  \item{metacol}{sub-array index in the column}
  \item{x}{fictitious x coordinate}
  \item{y}{fictitious y coordinate}
}
%\references{ ~put references to the literature/web site here ~ }
%\author{ ~~who you are~~ }
%\note{ ~~further notes~~ 
%
% ~Make other sections like Warning with \section{Warning }{....} ~
%}
%\seealso{ ~~objects to See Also as \code{\link{help}}, ~~~ }
\examples{
# array with 10,000 probes
one_plex <- createProbeCoords(100, 100)
plot(y ~ x, data=one_plex, pch=".",
     main = "array 1x10k")

# 4x2.5k array
four_plex <- createProbeCoords(50, 50, 2, 2)
plot(y ~ x, data=four_plex, pch=".",
     main = "array 4x2.5k")

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ manip }

